'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes3 = require('./struct/propTypes');

var _propTypes4 = _interopRequireDefault(_propTypes3);

var _MouseMoveTracker = require('./dom/MouseMoveTracker');

var _MouseMoveTracker2 = _interopRequireDefault(_MouseMoveTracker);

var _utils = require('./utils');

var _FlexiGridCell = require('./FlexiGridCell');

var _FlexiGridCell2 = _interopRequireDefault(_FlexiGridCell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FlexiGridColumnReorderHandler = function (_React$Component) {
  (0, _inherits3.default)(FlexiGridColumnReorderHandler, _React$Component);

  function FlexiGridColumnReorderHandler(props) {
    (0, _classCallCheck3.default)(this, FlexiGridColumnReorderHandler);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FlexiGridColumnReorderHandler.__proto__ || (0, _getPrototypeOf2.default)(FlexiGridColumnReorderHandler)).call(this, props));

    _this.onColumnReordering = function (deltaX) {
      if (deltaX !== 0) {
        var state = _this.cache || _this.state;
        var newLeft = state.delta + deltaX;
        var newFixedLeft = (0, _utils.clamp)(newLeft, _this.state.minLeft, _this.state.maxLeft);
        _this.cache = {
          movingLeft: deltaX < 0,
          left: newFixedLeft,
          delta: newLeft
        };
      }
    };

    _this.onColumnReordered = function () {
      var targetKey = _this.cache && _this.cache.targetKey;
      (0, _utils.cancelAnimationFrame)(_this.frameId);
      _this.cache = null;
      _this.frameId = null;
      _this.animating = false;

      _this.mouseMoveTracker.release();
      if (_this.props.onColumnReordered) {
        _this.props.onColumnReordered(targetKey);
      }
    };

    _this.updateState = function () {
      if (_this.animating) {
        _this.frameId = (0, _utils.requestAnimationFrame)(_this.updateState);
      }

      if (_this.cache) {
        var _this$props = _this.props,
            column = _this$props.column,
            targets = _this$props.targets,
            factor = _this$props.factor;
        var _this$cache = _this.cache,
            left = _this$cache.left,
            movingLeft = _this$cache.movingLeft;

        var right = left + column.width;

        var currentTarget = null;
        var tryLeftSide = function tryLeftSide() {
          targets.some(function (target) {
            if (target.key !== column.key && left > target.left && left < target.left + target.width * factor) {
              currentTarget = {
                targetKey: target.key,
                targetPosition: target.left,
                isLeftTarget: true,
                visible: target.leftSideVisible
              };
              return true;
            }

            return false;
          });
        };
        var tryRightSide = function tryRightSide() {
          for (var i = targets.length - 1; i >= 0; i -= 1) {
            var target = targets[i];
            if (target.key !== column.key && right < target.left + target.width && right > target.left + target.width * (1 - factor)) {
              currentTarget = {
                targetKey: target.key,
                targetPosition: target.left + target.width,
                isLeftTarget: false,
                visible: target.rightSideVisible
              };
              break;
            }
          }
        };

        if (movingLeft) {
          tryLeftSide();
        } else {
          tryRightSide();
        }

        if (!currentTarget) {
          if (movingLeft) {
            tryRightSide();
          } else {
            tryLeftSide();
          }
        }

        if (!currentTarget) {
          currentTarget = {
            targetKey: null,
            targetPosition: 0,
            isLeftTarget: true
          };
        }

        if (!currentTarget.visible) {
          currentTarget.targetKey = null;
        }

        _this.cache = (0, _extends3.default)({}, _this.cache, currentTarget);

        _this.setState(_this.cache);

        if (_this.props.onColumnReordering) {
          _this.props.onColumnReordering({
            targetKey: currentTarget.targetKey,
            position: left,
            movingLeft: movingLeft
          });
        }
      }
    };

    _this.state = {
      minLeft: 0,
      maxLeft: 0,
      left: 0
    };
    _this.cache = null;
    _this.animating = false;
    return _this;
  }

  (0, _createClass3.default)(FlexiGridColumnReorderHandler, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.mouseMoveTracker = new _MouseMoveTracker2.default(document.body, this.onColumnReordering, this.onColumnReordered);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      if (props.initialEvent && !this.mouseMoveTracker.isDragging()) {
        this.mouseMoveTracker.capture(props.initialEvent);

        var column = props.column,
            targets = props.targets,
            offsetLeft = props.offsetLeft;

        var minLeft = targets.length ? targets[0].left : offsetLeft;
        var maxLeft = targets.length ? targets[targets.length - 1].left + targets[targets.length - 1].width - column.width : offsetLeft;

        this.setState({
          minLeft: minLeft,
          maxLeft: maxLeft,
          left: offsetLeft,
          delta: offsetLeft,
          targetKey: null,
          targetPosition: 0
        });

        this.cache = null;
        this.animating = true;
        this.frameId = (0, _utils.requestAnimationFrame)(this.updateState);
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _utils.shallowEqual)(this.props, nextProps) || !(0, _utils.shallowEqual)(this.state, nextState);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.mouseMoveTracker.release();
      this.mouseMoveTracker = null;
    }
  }, {
    key: 'renderDropTargets',
    value: function renderDropTargets() {
      var targets = this.props.targets;

      return (targets || []).map(function (_ref) {
        var key = _ref.key,
            style = (0, _objectWithoutProperties3.default)(_ref, ['key']);
        return _react2.default.createElement('div', {
          key: key,
          style: style,
          className: 'drop-target'
        });
      });
    }
  }, {
    key: 'renderSourceMask',
    value: function renderSourceMask() {
      var _props = this.props,
          column = _props.column,
          columnHeight = _props.columnHeight,
          borderSize = _props.borderSize,
          offsetLeft = _props.offsetLeft,
          offsetTop = _props.offsetTop;

      return column ? _react2.default.createElement('div', {
        className: 'source-mask',
        style: {
          left: offsetLeft,
          top: offsetTop,
          height: columnHeight - borderSize,
          width: column.width - borderSize
        }
      }) : null;
    }
  }, {
    key: 'renderHeaderMergedCells',
    value: function renderHeaderMergedCells(height, left, column) {
      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          rowHeight = _props2.rowHeight;
      var children = column.children,
          width = column.width,
          title = column.title,
          align = column.align,
          key = column.key;

      var cellProps = {
        prefixCls: prefixCls,
        width: width,
        height: rowHeight,
        left: 0,
        align: align || 'center',
        render: title
      };

      return _react2.default.createElement(
        'div',
        {
          key: key + '-merged-cells-wrap',
          className: prefixCls + '-header-merged-cells-wrap',
          style: { width: width, height: height, left: left }
        },
        _react2.default.createElement(_FlexiGridCell2.default, cellProps),
        _react2.default.createElement(
          'div',
          {
            key: key + '-merged-cells',
            className: prefixCls + '-header-merged-cells',
            style: {
              width: width,
              height: height - rowHeight,
              top: rowHeight
            }
          },
          this.renderHeaderCells(children, height - rowHeight)
        )
      );
    }
  }, {
    key: 'renderHeaderCells',
    value: function renderHeaderCells(columns, height) {
      var _this2 = this;

      var prefixCls = this.props.prefixCls;


      var left = 0;

      return columns.map(function (column) {
        var children = column.children,
            width = column.width,
            title = column.title,
            key = column.key;

        var ret = void 0;

        if (children) {
          ret = _this2.renderHeaderMergedCells(height, left, column);
        } else {
          var cellProps = {
            key: key,
            prefixCls: prefixCls,
            width: width,
            height: height,
            left: left,
            render: title
          };

          ret = _react2.default.createElement(_FlexiGridCell2.default, cellProps);
        }

        left += width;

        return ret;
      });
    }
  }, {
    key: 'renderDragKnob',
    value: function renderDragKnob(column, height, offsetLeft, offsetTop) {
      var _props3 = this.props,
          prefixCls = _props3.prefixCls,
          knobSize = _props3.knobSize;

      var style = {
        top: offsetTop,
        left: offsetLeft,
        width: knobSize,
        height: height
      };
      var className = (0, _classnames2.default)(prefixCls + '-reorder-knob', {
        active: column === this.props.column
      });

      return _react2.default.createElement('div', {
        key: column.key,
        style: style,
        className: className
      });
    }
  }, {
    key: 'renderDragKnobs',
    value: function renderDragKnobs(columns, height, offsetLeft, offsetTop) {
      var _this3 = this;

      var rowHeight = this.props.rowHeight;

      var knobs = [];
      var left = offsetLeft;

      columns.forEach(function (column) {
        if (column.children) {
          knobs.push.apply(knobs, [_this3.renderDragKnob(column, rowHeight, left, offsetTop)].concat((0, _toConsumableArray3.default)(_this3.renderDragKnobs(column.children, height - rowHeight, left, offsetTop + rowHeight))));
        } else {
          knobs.push(_this3.renderDragKnob(column, height, left, offsetTop));
        }
        left += column.width;
      });

      return knobs;
    }
  }, {
    key: 'renderDragProxy',
    value: function renderDragProxy() {
      if (this.props.column) {
        var left = this.state.left;
        var _props4 = this.props,
            column = _props4.column,
            columnHeight = _props4.columnHeight,
            offsetTop = _props4.offsetTop;

        return _react2.default.createElement(
          'div',
          {
            className: 'drag-proxy',
            style: {
              width: column.width,
              height: columnHeight,
              top: offsetTop,
              left: left
            }
          },
          this.renderHeaderCells([column], columnHeight),
          this.renderDragKnobs([column], columnHeight, 0, 0)
        );
      }

      return null;
    }
  }, {
    key: 'renderDropMarker',
    value: function renderDropMarker() {
      var _props5 = this.props,
          columnHeight = _props5.columnHeight,
          offsetTop = _props5.offsetTop,
          width = _props5.width;
      var _state = this.state,
          targetKey = _state.targetKey,
          targetPosition = _state.targetPosition,
          isLeftTarget = _state.isLeftTarget;

      if (targetKey) {
        var className = (0, _classnames2.default)('target-marker', {
          'is-left': isLeftTarget,
          'is-right': !isLeftTarget
        });
        var style = {
          height: columnHeight,
          top: offsetTop
        };
        if (isLeftTarget) {
          style.left = targetPosition;
        } else {
          style.right = width - targetPosition;
        }

        return _react2.default.createElement('div', { className: className, style: style });
      }

      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props6 = this.props,
          prefixCls = _props6.prefixCls,
          visible = _props6.visible,
          width = _props6.width,
          height = _props6.height;

      var className = (0, _classnames2.default)(prefixCls + '-reorder-handler', {
        visible: visible
      });

      var wrapStyle = {
        width: width,
        height: height
      };

      return _react2.default.createElement(
        'div',
        { className: className, style: wrapStyle },
        this.renderDropTargets(),
        this.renderSourceMask(),
        this.renderDropMarker(),
        this.renderDragProxy()
      );
    }
  }]);
  return FlexiGridColumnReorderHandler;
}(_react2.default.Component); /* eslint-disable react/require-default-props */


FlexiGridColumnReorderHandler.propTypes = {
  prefixCls: _propTypes2.default.string,
  column: _propTypes4.default.column,
  targets: _propTypes4.default.dropTarget,
  visible: _propTypes2.default.bool,
  factor: _propTypes2.default.number,
  width: _propTypes2.default.number,
  height: _propTypes2.default.number,
  rowHeight: _propTypes2.default.number,
  columnHeight: _propTypes2.default.number,
  offsetLeft: _propTypes2.default.number,
  offsetTop: _propTypes2.default.number,
  borderSize: _propTypes2.default.number,
  knobSize: _propTypes2.default.number,
  initialEvent: _propTypes4.default.domEvent,
  onColumnReordering: _propTypes2.default.func,
  onColumnReordered: _propTypes2.default.func
};
FlexiGridColumnReorderHandler.defaultProps = {
  visible: false,
  factor: 3 / 4,
  width: 0,
  height: 0,
  rowHeight: 0,
  columnHeight: 0,
  offsetLeft: 0,
  offsetTop: 0,
  borderSize: 0,
  knobSize: 0,
  targets: [],
  initialEvent: null
};
exports.default = FlexiGridColumnReorderHandler;
module.exports = exports['default'];